---
variables:
  TF_ROOT: ${CI_PROJECT_DIR}

cache: &global_cache
  key: "${CI_COMMIT_REF_SLUG}"
  paths:
    - ${TF_ROOT}/.terraform/
  policy: pull-push

stages:
  - init
  - validate

init:
  stage: init
  image:
    name: hashicorp/terraform:0.13.5
    entrypoint: ["/bin/sh", "-c"]
  script:
    - cd ${TF_ROOT}
    - terraform init -get=true -get-plugins=true -upgrade=false -input=false
    - terraform version

validate:
  stage: validate
  image:
    name: hashicorp/terraform:latest
    entrypoint: ["/bin/sh", "-c"]
  cache:
    <<: *global_cache
    policy: pull
  before_script:
    - cd ${TF_ROOT}
    - terraform init -get=true -get-plugins=true -upgrade=false -input=false
    - terraform version
  script:
    - cd ${TF_ROOT}
    - terraform fmt -check=true -write=false
    - terraform validate
